#INCLUDE 'SERA.CH'

******************************************
*   FILE HANDLING FUNCTIONS              *
******************************************

FUNCTION SERAAPPEND
DBGOBOTTOM()
DBAPPEND()
IF TYPE('CREATEDBY_') = 'C' .AND. TYPE('WFSTATUS_') = 'C'
 _FIELD->CREATEDBY_ := PROCNAME
 _FIELD->CREATEDDT_ := DATE()
 _FIELD->CREATEDTM_ := TIME()
 _FIELD->UPDATEBY_ := PROCNAME
 _FIELD->UPDATEDT_ := DATE()
 _FIELD->UPDATETM_ := TIME()
 _FIELD->WFSTATUS_ := '0'
 _FIELD->WFDATE_ := DATE()
ENDIF
RETURN

FUNCTION SERAGOTOP
IF INDEXORD() = 0 .OR. EMPTY(INDEXKEY(1))
 DBGOTOP(1)   //  (1) TO AVOID TRANSLATION TO SERAGOTOP BY SERA.CH
ELSE
 SEEK SPACE(1) // CHR(10)
ENDIF
RETURN

FUNCTION DBCOPYSTRU
PARAMETERS USENAME
USENAME = UPPER(USENAME)
USESHORT = ALLTRIM(USENAME)
USEDRIVER = RDDSETDEFAULT()
IF '.'$USESHORT
 USESHORT = SUBS(USESHORT,1,RAT('.',USESHORT)-1)
ENDIF
IF '\'$USESHORT
 USESHORT := trim(subs( USESHORT, RAT( "\", USESHORT )+1))
ELSE
 USESHORT = trim(USESHORT)
ENDIF
IF '\SERA\DATA'$USENAME
 USENAME = DBO+'\'+USESHORT
ELSE
 RDDSETDEFAULT('DBFNTX')
ENDIF
__dbCopyStruct( USENAME, { } )
RDDSETDEFAULT(USEDRIVER)
RETURN

FUNCTION DBAPPEFROM
PARAMETERS USENAME
USENAME = UPPER(USENAME)
USESHORT = ALLTRIM(USENAME)
USEDRIVER = RDDSETDEFAULT()
IF '.'$USESHORT
 USESHORT = SUBS(USESHORT,1,RAT('.',USESHORT)-1)
ENDIF
IF '\'$USESHORT
 USESHORT := trim(subs( USESHORT, RAT( "\", USESHORT )+1))
ELSE
 USESHORT = trim(USESHORT)
ENDIF
IF '\SERA\DATA'$USENAME
 USENAME = DBO+'\'+USESHORT
ELSE
 RDDSETDEFAULT('DBFNTX')
ENDIF
__dbApp( USENAME, { },,,,, .F., )
RDDSETDEFAULT(USEDRIVER)
RETURN

FUNCTION DBCOPYTO
PARAMETERS USENAME
USENAME = UPPER(USENAME)
USESHORT = ALLTRIM(USENAME)
USEDRIVER = RDDSETDEFAULT()
IF '.'$USESHORT
 USESHORT = SUBS(USESHORT,1,RAT('.',USESHORT)-1)
ENDIF
IF '\'$USESHORT
 USESHORT := trim(subs( USESHORT, RAT( "\", USESHORT )+1))
ELSE
 USESHORT = trim(USESHORT)
ENDIF
IF '\SERA\DATA'$USENAME
 USENAME = DBO+'\'+USESHORT
ELSE
 RDDSETDEFAULT('DBFNTX')
ENDIF
__dbCopy( USENAME, { },,,,, .F., )
RDDSETDEFAULT(USEDRIVER)
RETURN

FUNCTION DBSETNTX
PARAMETERS USENAME
IF EMPTY(USENAME)
 RETURN
ENDIF
USENAME = UPPER(USENAME)
USESHORT = ALLTRIM(USENAME)
USEDRIVER = RDDSETDEFAULT()
IF '.'$USESHORT
 USESHORT = SUBS(USESHORT,1,RAT('.',USESHORT)-1)
ENDIF
IF '\'$USESHORT
 USESHORT := trim(subs( USESHORT, RAT( "\", USESHORT )+1))
ELSE
 USESHORT = trim(USESHORT)
ENDIF
SQLDRIVER = .T.
IF .NOT. '\SERA\DATA'$USENAME
 SQLDRIVER = .F.
ENDIF
IF SQLDRIVER
 USENAME = USESHORT
ELSE
 RDDSETDEFAULT('DBFNTX')
ENDIF
DbSetIndex ( USENAME)
IF EMPTY(_SELARR[_SELACT,5])
 _SELARR[_SELACT,5] = USENAME
ENDIF
RDDSETDEFAULT(USEDRIVER)
RETURN

FUNCTION SETINDEX
PRIVATE I_NAM,I_ADD,I_FIL
PARAMETERS I_NAM,I_ADD
I_NAM = UPPER(I_NAM)
IF '\'$I_NAM
 I_FIL  := trim(subs( I_NAM, RAT( "\", I_NAM )+1))
ELSE
 I_FIL := trim(I_NAM )
ENDIF
IF '.'$I_FIL
 I_FIL = SUBS(I_FIL,1,RAT('.',I_FIL)-1)
ENDIF
IF .NOT. I_ADD
 ordListClear()
 _SELARR[_SELACT,5] = SPACE(0)
ENDIF
IF '\SERA\DATA'$I_NAM
 I_NAM = I_FIL
ENDIF
ordListAdd( I_NAM )
IF EMPTY(_SELARR[_SELACT,5])
 _SELARR[_SELACT,5] = I_FIL
ENDIF
DBGOTOP(1)
RETURN

FUNCTION SERAINDEX
* SYNTAX  SERAINDEX(<INDEXKEY>,<INDEXFILE>)
* REPLACES INDEX ON <INDEXKEY> TO <INDEXFILE>
* A PROGRESSION BAR WILL BE SHOWN DURING INDEXING
PARAMETER SIKEY , SIFILE
ORGDRIVER = RDDSETDEFAULT()
SIFILE = UPPER(SIFILE)
SQLDRIVER = .T.
IF .NOT. '\SERA\DATA'$SIFILE
 SQLDRIVER = .F.
ENDIF
IF SQLDRIVER
 RDDSETDEFAULT("MEDNTX")
 IF '\'$SIFILE
  SIFILE = UPPER(TRIM(SUBS(SIFILE,RAT( "\", SIFILE )+1)))
 ELSE
  SIFILE = UPPER(ALLTRIM(SIFILE))
 ENDIF
 IF '.NTX'$SIFILE
  SIFILE = SUBS(SIFILE,1,AT('.',SIFILE)-1)
 ENDIF
 IF MEDISIDX(SELECT(),SIFILE)
  MEDDROPIDX(SELECT(),SIFILE)
 ENDIF
ELSE
 RDDSETDEFAULT("DBFNTX")
ENDIF
dbCreateIndex( SIFILE, SIKEY, {|| &SIKEY}, if( .F., .T., NIL ) )
RDDSETDEFAULT(ORGDRIVER)
RETURN

FUNCTION BEGINTRANS
DBCOMMITALL()
MEDTRBEGIN(0)
IF MEDTRRES() = 0
 ROLLBACK = .T.
ELSE
 DBCOMMITALL()
 DBUNLOCKALL()
 MEDTRCOMM()
 ROLLBACK = .F.
ENDIF
RETURN

FUNCTION ENDTRANS
IF .NOT. ROLLBACK
 RETURN
ENDIF
DBCOMMITALL()
DBUNLOCKALL()
MEDTRCOMM()
ROLLBACK = .F.
RETURN



FUNCTION GETEXEDIR
EXE_DIR = SQLREAD('ExecutablesLocation')
IF .NOT. EMPTY(EXE_DIR)
 RETURN EXE_DIR
ENDIF
RETURN '\SERA'



FUNCTION SERASELECT
PARAMETER _SELPAR
IF TYPE('_SELPAR') = 'N'
 _SELACT = _SELPAR
 dbSelectArea(_SELACT)
 RETURN _SELACT
ENDIF
IF EMPTY(_SELPAR)
 IF _SELACT = 0
  _SELACT = BASESELECT()
 ENDIF
 RETURN _SELACT
ENDIF

_SELPAR = UPPER(ALLTRIM(_SELPAR))
_SELNEW = .T.

IF _SELPAR < 'A'
 _SELPRG = VAL(_SELPAR)
 IF _SELPRG = 0
  // NEW
  _SELACT = ASCAN(_SELARR,{|AVAL|EMPTY(AVAL[2])})
 ELSE
  _SELACT = ASCAN(_SELARR,{|AVAL|AVAL[1]=_SELPRG})
  IF _SELACT > 0
   // EXISTING
  _SELNEW = .F.
  ELSE
   // NEW
   _SELACT = ASCAN(_SELARR,{|AVAL|EMPTY(AVAL[2])})
   IF _SELACT > 0
    _SELARR[_SELACT] = {_SELPRG,SPACE(0),SPACE(0),SET(8),SPACE(0)}
   ENDIF
  ENDIF
 ENDIF
 IF _SELACT = 0
  // MAXIMUM OPEN TABLES REACHED
  _SELACT = 150
  DO WHILE _SELACT < 254
   _SELACT = _SELACT + 1
   _SELARR[_SELACT] = {0,SPACE(0),SPACE(0),.F.,SPACE(0)}
   dbSelectArea(_SELACT)
   DBCLOSEAREA()
  ENDDO
  _SELACT = 151
  _SELARR[_SELACT] = {_SELPRG,SPACE(0),SPACE(0),.F.,SPACE(0)}
 ENDIF
 dbSelectArea(_SELACT)
 IF .NOT. _SELNEW
  *WINSHOWSEL()
 ENDIF
 RETURN _SELACT
ENDIF

IF _SELPAR = 'CLOSE'
 _SELPAR = ALLTRIM(UPPER(ALIAS()))
 _SELACT = ASCAN(_SELARR,{|AVAL|AVAL[3]=_SELPAR})
 IF _SELACT = 0
  // TABLE IS NOT OPEN
  RETURN _SELACT
 ENDIF
 // CLOSE TABLE  -> _SELPRG = -1
 _TMP2 = _SELARR[_SELACT,2]
 _TMP3 = _SELARR[_SELACT,3]
 _TMP4 = _SELARR[_SELACT,4]
 _TMP5 = _SELARR[_SELACT,5]
 _SELARR[_SELACT] = {-1,_TMP2,_TMP3,_TMP4,_TMP5}
 _SELPRG = 0
 _SELNEW = .T.
 dbSelectArea(_SELACT)
 IF ALIAS() > ' '
  dbClearFilter()
  dbClearRel()
  ordListClear()
  dbClearFilter(NIL)
  DBGOTOP(1)
 ENDIF
 RETURN _SELACT
ENDIF

IF _SELPAR > 'A '
 _SELACT = ASCAN(_SELARR,{|AVAL|AVAL[3]=_SELPAR})
 IF _SELACT = 0
  // TABLE IS NOT OPEN
  RETURN _SELACT
 ENDIF
 // EXISTING
 IF _SELARR[_SELACT,1] = -1
  // CLOSED
  dbSelectArea(_SELACT)
  RETURN 0
 ENDIF
 _SELPRG = 0
 _SELNEW = .F.
 dbSelectArea(_SELACT)
 IF .NOT. _SELNEW
  *WINSHOWSEL()
 ENDIF
 RETURN _SELACT
ENDIF
RETURN 0

FUNCTION CLOSEALL
DBCLOSEALL()
_SELACT   := 1
_SELPRG   := 0
_SELARR   := {}
DO WHILE _SELPRG < 254
 _SELPRG = _SELPRG + 1
 AADD(_SELARR,{0,SPACE(0),SPACE(0),.F.,SPACE(0)})
ENDDO
_SELPRG = 1
RETURN

FUNCTION ORDER1
IF .NOT. EMPTY(_SELARR[_SELACT,5]) .AND. .NOT. '\'$_SELARR[_SELACT,5]
 SET ORDER TO _SELARR[_SELACT,5]
ELSE
 ORDSETFOCUS(1)
ENDIF
RETURN

FUNCTION CREATETEMPFILE
PARAMETERS _TMPARR,_FILENAME,_DBTNAME,_INDEXNAME,_INDEXKEY,_TMPSEL
SELE TEMPMAST
DO WHILE .NOT. RLOCK()
ENDDO
REPL LASTNR WITH LASTNR + 1   // NO NEED TO BE AFRAID THAT IT COMES OVER 9999999
_DBF = 'T'+SUBS(STR(LASTNR+10000000,8),2,7)
_NTX = 'T'+SUBS(STR(LASTNR+10000000,8),2,7)
UNLOCK
_DBF2 = '\SERA\DATA\'+_DBF
_NTX2 = '\SERA\DATA\'+_NTX
COPY STRU TO &_DBF2
AADD(TMPFILES,_DBF)
PUBLIC &_FILENAME := _DBF2
_TMPCNT = 0
DO WHILE _TMPCNT < LEN(_TMPFILARR)
 _TMPCNT = _TMPCNT + 1
 _TMPARR = {}
 AADD(_TMPARR,{ _TMPFILARR[_TMPCNT,1],_TMPFILARR[_TMPCNT,2],_TMPFILARR[_TMPCNT,3],_TMPFILARR[_TMPCNT,4]})
 MEDCOLADD(DBO+'\'+_DBF,_TMPARR)
ENDDO
SET EXCL ON
SELE 0
USE &_DBF2
IF .NOT. EMPTY(_INDEXNAME) .AND. .NOT. EMPTY(_INDEXKEY)
 PUBLIC &_INDEXNAME := _NTX2
 INDEX ON &_INDEXKEY TO &_NTX2
ENDIF
DBCLOSEAREA()
RETURN


FUNCTION TEMPTEXT
PARAMETERS _FILENAME,_FILEEXT
IF '.'$_FILENAME
 _FILEEXT = TRIM(SUBS(_FILENAME,AT('.',_FILENAME)))
 _FILENAME = SUBS(_FILENAME,1,AT('.',_FILENAME)-1)
ENDIF
IF EMPTY(_FILEEXT)
 _FILEEXT = 'TXT'
ENDIF
_TMPLOCA = '\SERA\TEMP\'
IF SUBS(_FILEEXT,1,1) <> '.'
 _FILEEXT = '.' + _FILEEXT
ENDIF
DO WHILE .T.
 STORE TIME() TO _TIM_
 _TXT = "\SERA\TEMP\T"+SUBS(_TIM_,1,2)+SUBS(_TIM_,4,2)+SUBS(_TIM_,7,2)+_FILEEXT
 IF .NOT. FILE('&_TXT')
  EXIT
 ENDIF
ENDDO
AADD(TMPFILES,_TXT)
PUBLIC &_FILENAME := _TXT
RETURN



FUNCTION SQLREAD
PARAMETER SQLITEM
SQLLOGIN = MEMOREAD('\SERA\PARAMET\SQLSERV.PAR')
ASPLOGIN = MEMOREAD('\SERA\PARAMET\ASP.PAR')
PARLOCA = '\SERA\PARAMET\SQLSERV.PAR'
DO WHILE ' :'$SQLLOGIN
 SQLLOGIN = STRTRAN(SQLLOGIN,' :',':')
 ASPLOGIN = STRTRAN(ASPLOGIN,' :',':')
ENDDO
// ADJUST OLD PARAMETERS TO NEW STYLE
IF .NOT. 'SERVER:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLTEMP = SQLTEMP + 'Server:'+TRIM(MEMOLINE(SQLLOGIN,,1))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'Port:'+TRIM(MEMOLINE(SQLLOGIN,,2))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'User:'+TRIM(MEMOLINE(SQLLOGIN,,3))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'PW:'+TRIM(MEMOLINE(SQLLOGIN,,4))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'Database:'+TRIM(MEMOLINE(SQLLOGIN,,5))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'Owner:'+TRIM(MEMOLINE(SQLLOGIN,,6))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'ExecutablesLocation:'+TRIM(MEMOLINE(ASPLOGIN,,1))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'LocalDrive:'+TRIM(MEMOLINE(ASPLOGIN,,2))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'RDPaddress:'+TRIM(MEMOLINE(ASPLOGIN,,3))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'RDPpw:'+TRIM(MEMOLINE(ASPLOGIN,,4))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'DocumentsLocation:'+TRIM(MEMOLINE(ASPLOGIN,,5))+CHR(13)+CHR(10)
 SQLTEMP = SQLTEMP + 'WebSite:'+CHR(13)+CHR(10)
 MEMOWRIT(PARLOCA,SQLTEMP)
 SQLLOGIN = SQLTEMP
ENDIF
IF .NOT. 'DOCUMENTSLOCATION:'$UPPER(SQLLOGIN)
 SQLLOGIN = STRTRAN(SQLLOGIN,'LocalDocumentDrive','DocumentsLocation')
 MEMOWRIT(PARLOCA,SQLLOGIN)
 IF .NOT. 'DOCUMENTSLOCATION:'$UPPER(SQLLOGIN)
  SQLTEMP = SPACE(0)
  SQLCNT = 0
  DO WHILE SQLCNT < 30
   SQLCNT = SQLCNT + 1
   IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
    SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
   ENDIF
  ENDDO
  SQLTEMP = SQLTEMP + 'DocumentsLocation:'+CHR(13)+CHR(10)
  SQLLOGIN = SQLTEMP
  MEMOWRIT(PARLOCA,SQLTEMP)
 ENDIF
ENDIF
IF .NOT. 'COMMERCIALLOCATION:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'CommercialLocation:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'SCANNERLOCATION:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'ScannerLocation:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'LOCALDRIVE:'$UPPER(SQLLOGIN)
 SQLLOGIN = STRTRAN(SQLLOGIN,'LocalExcellocation','LocalDrive')
 MEMOWRIT(PARLOCA,SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'LocalDrive:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'LOCALGROUP:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'LocalGroup:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'RDPADDRESS:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'RDPaddress:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'RDPpw:'$SQLLOGIN
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'RDPpw:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'EXCELPORT:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'ExcelPort:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'WEBODBC:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'WebODBC:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'WEBSITE:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'WebSite:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'CENTRALODBC:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'CentralODBC:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'CENTRALID:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'CentralID:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'CENTRALMEMBERS:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'CentralMembers:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
IF .NOT. 'SLOWREMOTEMAPS:'$UPPER(SQLLOGIN)
 SQLTEMP = SPACE(0)
 SQLCNT = 0
 DO WHILE SQLCNT < 30
  SQLCNT = SQLCNT + 1
  IF .NOT. EMPTY(TRIM(MEMOLINE(SQLLOGIN,,SQLCNT)))
   SQLTEMP = SQLTEMP + TRIM(MEMOLINE(SQLLOGIN,,SQLCNT))+CHR(13)+CHR(10)
  ENDIF
 ENDDO
 SQLTEMP = SQLTEMP + 'SlowRemoteMaps:'+CHR(13)+CHR(10)
 SQLLOGIN = SQLTEMP
 MEMOWRIT(PARLOCA,SQLTEMP)
ENDIF
SQLLOGIN = SQLLOGIN+CHR(13)+CHR(10)
SQLLOGIN = STRTRAN(SQLLOGIN,CHR(141),CHR(13)+CHR(10))
IF EMPTY(SQLITEM)
 RETURN SQLLOGIN
ENDIF
SQLITEM = ALLTRIM(UPPER(SQLITEM))+':'
SQLITEM = STRTRAN(SQLITEM,'::',':')
SQLRETURN = SUBS(SQLLOGIN,AT(SQLITEM,UPPER(SQLLOGIN))+LEN(SQLITEM))
SQLRETURN = ALLTRIM(SUBS(SQLRETURN,1,AT(CHR(13),SQLRETURN)-1))
IF SQLITEM = 'DOCUMENTSLOCATION:'
 IF EMPTY(SQLRETURN)
  SQLRETURN =DR+':\SERA\MAILER'
 ENDIF
ENDIF
IF SQLITEM = 'COMMERCIALLOCATION:'
 IF EMPTY(SQLRETURN)
  SQLRETURN  = DR+':\COMMERCE'
 ENDIF
ENDIF
IF SQLITEM = 'SCANNERLOCATION:'
 IF EMPTY(SQLRETURN)
  SQLRETURN = SUBS(SQLLOGIN,AT('DOCUMENTSLOCATION:',UPPER(SQLLOGIN))+LEN('DOCUMENTSLOCATION:'))
  SQLRETURN = ALLTRIM(SUBS(SQLRETURN,1,AT(CHR(13),SQLRETURN)-1))
  IF EMPTY(SQLRETURN)
   SQLRETURN = DR+':\SERA\MAILER'
  ENDIF
  IF .NOT. '\PURCHASE\RECEIVED'$UPPER(SQLRETURN)
   SQLRETURN = TRIM(SQLRETURN)+'\PURCHASE\RECEIVED'
  ENDIF
 ENDIF
ENDIF
RETURN SQLRETURN

FUNCTION DBSERAUSE
PARAMETERS USENAME,USEALIAS,USEDRIVER,USENEW
IF TYPE('USENEW') <> 'L'
 USENEW = .F.
ENDIF
USENAME = UPPER(USENAME)
USESHORT = ALLTRIM(USENAME)
IF '.'$USESHORT
 USESHORT = SUBS(USESHORT,1,RAT('.',USESHORT)-1)
ENDIF
IF '\'$USESHORT
 USESHORT := SUBS(USESHORT,RAT("\",USESHORT)+1)
ENDIF
IF '/'$USESHORT
 USESHORT := SUBS(USESHORT,RAT("/",USESHORT)+1)
ENDIF
USESHORT = TRIM(USESHORT)
IF _SELPRG > 0
 _SELTMP = ASCAN(_SELARR,{|AVAL|AVAL[1]=_SELPRG})
 IF _SELTMP > 0
  // REMOVE OLD SELECT
  _TMP2 = _SELARR[_SELTMP,2]
  _TMP3 = _SELARR[_SELTMP,3]
  _TMP4 = _SELARR[_SELTMP,4]
  _TMP5 = _SELARR[_SELTMP,5]
  _SELARR[_SELTMP] = {0,_TMP2,_TMP3,_TMP4,_TMP5}
 ENDIF
ENDIF
IF .NOT. EMPTY(USEALIAS)
 _SELNAM = UPPER(ALLTRIM(USEALIAS))
ELSE
 _SELNAM = USESHORT
ENDIF
_SELACT = ASCAN(_SELARR,{|AVAL|AVAL[3]+'|'=_SELNAM+'|'})
IF _SELACT > 0
 // EXISTING OR OPENED EARLIER
 _SELNEW = .F.
 IF _SELARR[_SELACT,4] .OR. SET(8)   // EARLIER EXCLUSIVE OR EXCLUSIVE NOW
  _SELNEW = .T.
 ENDIF
ELSE
 // NEVER USED
 _SELACT = ASCAN(_SELARR,{|AVAL|EMPTY(AVAL[2])})
 _SELNEW = .T.
ENDIF
IF _SELACT = 0
 // MAXIMUM OPEN TABLES REACHED
 _SELACT = 150
 DO WHILE _SELACT < 254
  _SELACT = _SELACT + 1
  _SELARR[_SELACT] = {0,SPACE(0),SPACE(0),.F.,SPACE(0)}
   dbSelectArea(_SELACT)
   DBCLOSEAREA()
 ENDDO
 _SELACT = 151
ENDIF
IF _SELPRG = 0
 _SELPRG = _SELARR[_SELACT,1]
ENDIF
_SELARR[_SELACT] = {_SELPRG,USESHORT,_SELNAM,SET(8),SPACE(0)}
dbSelectArea(_SELACT)
dbClearRel()
IF .NOT. EMPTY(ALIAS())
 dbClearFilter(NIL)
ENDIF
IF .NOT. _SELNEW .AND. .NOT. EMPTY(ALIAS())
 ordListClear()
 dbGoTop(1)
 dbClearFilter(NIL)
 dbGoTop(1)
ENDIF
IF _SELNEW
 USEDRIVER = 'MEDNTX'
 IF .NOT. '\SERA\DATA'$USENAME
  USEDRIVER = 'DBFNTX'
 ENDIF
 IF EMPTY(USEDRIVER) .OR. 'MEDNTX'$UPPER(USEDRIVER)
  USENAME = USESHORT
 ENDIF
 IF '\SERA\'$USENAME .AND. .NOT. '\DATA\'$USENAME .AND. .NOT. SET(8)
  SET EXCL ON
 ENDIF
 IF USEDRIVER <> 'DBFNTX' .AND. .NOT. EMPTY(DBO)
  USENAME = DBO+'\'+USENAME
 ENDIF
 MED_RES = 1
 MED_CNT = 0
 MEDIDXLMT(10)
 DO WHILE MED_RES <> 0 .AND. MED_CNT < 20
  DBUSEAREA (USENEW,USEDRIVER,USENAME,USEALIAS)
  IF USEDRIVER <> 'MEDNTX'
   EXIT
  ENDIF
  IF EMPTY(FIELD(1)) .AND. '\'$USENAME
   TMPNAME = SUBS(USENAME,AT('\',USENAME)+1)
   IF MEDISTABLE(TMPNAME)
    USENAME = TMPNAME
   ENDIF
   LOOP
  ENDIF
  MED_RES = MEDCMDRES()
  MED_CNT = MED_CNT+1
  IF MED_CNT > 1
   _SECONDS_ = SECONDS()
   DO WHILE ABS(SECONDS() - _SECONDS_) < .05
   ENDDO
  ENDIF
 ENDDO
 dbClearFilter(NIL)
 IF .T.
  _XCOUNT_ = 0
  DO WHILE _XCOUNT_ < 100
   _XCOUNT_ = _XCOUNT_ + 1
  ENDDO
 ENDIF
ENDIF
RETURN

FUNCTION ALLINDEXES
PARAMETER TABLENAME
IF EMPTY(TABLENAME) .OR. SET(8) .OR. EMPTY(INDEXKEY())
 RETURN
ENDIF
TABLENAME = UPPER(ALLTRIM(TABLENAME))
IF .NOT. '\SERA\DATA\'$TABLENAME
 RETURN
ENDIF
TABLENAME = STRTRAN(TABLENAME,'\SERA\DATA\')
TABLENAME = STRTRAN(TABLENAME,'.DBF')
IF TRIM(TABLENAME)$'FILELIST'
 RETURN
ENDIF
_AINDEX = {}
_FLISTCNT = 0
DO WHILE _FLISTCNT < 7
 _FLISTCNT = _FLISTCNT + 1
 IF .NOT. EMPTY(INDEXKEY(_FLISTCNT))
  AADD(_AINDEX,INDEXKEY(_FLISTCNT))
 ENDIF
ENDDO
_FLISTSEL = SELECT()
IF SELECT('FILELIST') = 0
 dbClearFilter(NIL)
 SELE 0
 DBSERAUSE ( "\SERA\DATA\FILELIST",,,.F. ); DBSETNTX( "\SERA\DATA\FILELIST", )
 dbClearFilter(NIL)
ENDIF
SELE FILELIST
_FLISTREC = RECNO()
SEEK TABLENAME
IF .NOT. FOUND()
 GO _FLISTREC
 SELECT(_FLISTSEL)
 RETURN
ENDIF
_FLISTARR = {}
_FLISTNR = 0
DO WHILE _FLISTNR < 7
 _FLISTNR  = _FLISTNR + 1
 _FLISTKEY = 'FIINDEX'+STR(_FLISTNR,1)
 _FLISTNAM = TRIM(SUBS(&_FLISTKEY,RAT('\',&_FLISTKEY)+1))
 IF .NOT. EMPTY(_FLISTNAM)
  _FLISTOK = .T.
  _FLISTCNT = 0
  DO WHILE _FLISTCNT < LEN(_AINDEX)
   _FLISTCNT = _FLISTCNT + 1
   IF 'INDEX ON '+UPPER(_AINDEX[_FLISTCNT])+ 'TO '$UPPER(&_FLISTKEY)
    _FLISTOK = .F.
    EXIT
   ENDIF
  ENDDO
  IF _FLISTOK
   AADD(_FLISTARR,_FLISTNAM)
  ENDIF
 ENDIF
ENDDO
GO _FLISTREC
SELECT(_FLISTSEL)
_FLISTNR = 0
DO WHILE _FLISTNR < LEN(_FLISTARR)
 _FLISTNR = _FLISTNR + 1
 IF MEDISIDX(SELECT(),_FLISTARR[_FLISTNR])
  DBSETNTX('\SERA\DATA\'+_FLISTARR[_FLISTNR],)
 ENDIF
ENDDO
dbClearFilter(NIL)
RETURN


FUNCTION SERA_DBF
RDDSETDEFAULT("MEDNTX")
SQLSERVER = SQLREAD('SERVER')
SQLPORT = SQLREAD('PORT')
SQLUSER = SQLREAD('USER')
SQLPW = SQLREAD('PW')
SQLDB = SQLREAD('DATABASE')
LOGRES = MEDLOGIN("",SQLSERVER,SQLPORT,SQLUSER,SQLPW,SQLDB)
IF LOGRES > 0
 ERRTXT = MEDERRTEXT()
 IF LOGRES = 3
  ERRTXT = 'No access to server '+SQLSERVER
 ENDIF
 IF LOGRES = 5
  ERRTXT = 'ODBC needs windows authentication '+SQLSERVER
 ENDIF
 MESSAGEBOX(,'LOGIN ERROR '+ALLTRIM(STR(LOGRES,4))+'!'+CHR(13)+CHR(10)+ERRTXT,'MESSAGE')
 QUIT
ENDIF
MEDSETPERF(.T.)
MEDDISCTM(65535)  // KEEP CONNECTION ALIVE

DBO = SQLREAD('OWNER')
RETURN

FUNCTION SERADR
PUBLIC DR := UPPER(SUBS(DISKNAME(),1,1))
PUBLIC DOCUDR := TRIM(SQLREAD('DocumentsLocation'))
IF EMPTY(DOCUDR)
 MEMOWRIT('\SERA\PARAMET\SQLSERV.PAR',STRTRAN(MEMOREAD('\SERA\PARAMET\SQLSERV.PAR'),'DocumentsLocation:','DocumentsLocation:'+DR+':\SERA\MAILER'))
 DOCUDR = DR+':\SERA\MAILER'
ENDIF
IF SUBS(DOCUDR,2,1) <> ':'
 DOCUDR = DR+':'+DOCUDR
ENDIF
PUBLIC LOCALDR := SUBS(TRIM(SQLREAD('LocalDrive')),1,2)
IF EMPTY(LOCALDR)
 MEMOWRIT('\SERA\PARAMET\SQLSERV.PAR',STRTRAN(MEMOREAD('\SERA\PARAMET\SQLSERV.PAR'),'LocalDrive:','LocalDrive:L:'))
 LOCALDR = 'L:'
ENDIF
IF SUBS(LOCALDR,2,1) <> ':'
 LOCALDR = DR+':'
ENDIF
RETURN DR

FUNCTION TEMPDBF
PARAMETERS _TMPARR,_FILENAME,_DBTNAME,_INDEXNAME,_INDEXKEY,_TMPSEL
SELE TEMPMAST
DO WHILE .NOT. RLOCK()
ENDDO
REPL LASTNR WITH LASTNR + 1   // NO NEED TO BE AFRAID THAT IT COMES OVER 9999999
_TIM_ = SUBS(STR(LASTNR+10000000,8),2,7)
UNLOCK
IF TYPE('STOPTIME') <> 'N'
 PUBLIC STOPTIME := VAL(MEMOREAD('\SERA\PARAMET\STOPTIME.PAR'))
ENDIF
_TMP = "\SERA\TEMP\T"+_TIM_+".DBF"
_DBF = "\SERA\TEMP\D"+_TIM_+".DBF"
_DBT = "\SERA\TEMP\A"+_TIM_+".DBT"
_NTX = "\SERA\TEMP\C"+_TIM_+".NTX"
AADD(TMPDBFS,_DBF)
AADD(TMPDBFS,_NTX)
AADD(TMPDBFS,_DBT)
SET EXCL ON
ORGALLOW = EXITALLOW
dbSelectArea( "148" )
USEDRIVER = RDDSETDEFAULT()
RDDSETDEFAULT('DBFNTX')
__dbCreate( _TMP,, "DBFNTX", .F., )
dbcommit()
dbclosearea()
STOPSEC = SECONDS() + STOPTIME + STOPTIME
IF STOPTIME > 0 .AND. STOPSEC < 86000
 DO WHILE SECONDS() < STOPSEC
 ENDDO
ENDIF
dbSelectArea( "149" )
dbUseArea( .F.,"DBFNTX",_TMP,, if(.F. .OR. .F., !.F., NIL), .F. )
_TMPCNT = 0
_TMPLEN = LEN(_TMPARR)
DO WHILE _TMPCNT < _TMPLEN
 _TMPCNT = _TMPCNT + 1
 APPE BLANK
 FIELD->FIELD_NAME := _TMPARR[_TMPCNT,1]
 FIELD->FIELD_TYPE := _TMPARR[_TMPCNT,2]
 FIELD->FIELD_LEN := _TMPARR[_TMPCNT,3]
 FIELD->FIELD_DEC := _TMPARR[_TMPCNT,4]
ENDDO
PUBLIC &_FILENAME := _DBF
IF .NOT. EMPTY(_DBTNAME)
 PUBLIC &_DBTNAME := _DBT
ENDIF
dbcommit()
dbclosearea()
dbSelectArea( "150" )
CREATE &_DBF FROM &_TMP
IF STOPTIME > 0 .AND. STOPSEC < 86000
 DO WHILE SECONDS() < STOPSEC
 ENDDO
ENDIF
DBUSEAREA (.F.,'DBFNTX',_DBF)
IF .NOT. EMPTY(_INDEXNAME) .AND. .NOT. EMPTY(_INDEXKEY)
 PUBLIC &_INDEXNAME := _NTX
 INDEX ON &_INDEXKEY TO &_NTX
ENDIF
dbcommit()
dbclosearea()
IF STOPTIME > 0 .AND. STOPSEC < 86000
 DO WHILE SECONDS() < STOPSEC
 ENDDO
ENDIF
RDDSETDEFAULT(USEDRIVER)
SET EXCL ON
IF ORGALLOW
 EXITALLOW = .T.
ENDIF
RETURN

